ORIGIN		= DigiMars C++
ORIGIN_VER	= Version 7.22
VERSION		= DEBUG

!IFDEF SUB_DEBUG
DEBUG		= $(SUB_DEBUG)
NDEBUG		= !$(SUB_DEBUG)
!ELSE
DEBUG		= 1
NDEBUG		= 0
!ENDIF

PROJ		= compiler_tests
APPTYPE		= WIN32 CONSOLE
PROJTYPE	= EXE

CC		= SC
CPP		= SPP
JAVAC		= sj
MAKE		= SMAKE
RC		= RCC
HC		= HC31
ASM		= SC
DISASM		= OBJ2ASM
LNK		= LINK
DLLS		= 

HEADERS		= test_config.h ..\..\..\..\dm\include\stdio.h ..\..\..\..\dm\include\wchar.h  \
		..\..\..\..\dm\include\ctype.h ..\..\..\..\dm\include\direct.h ..\..\..\..\dm\include\io.h ..\..\..\..\dm\include\process.h  \
		..\..\..\..\dm\include\sys\stat.h ..\..\..\..\dm\include\stdlib.h ..\..\..\..\dm\include\string.h ..\..\..\..\dm\include\time.h 

DEFFILE		= compiler_tests.DEF

!IF $(DEBUG)
OUTPUTDIR	= .
CREATEOUTPUTDIR	=
TARGETDIR	= .
CREATETARGETDIR	=

SYMROOT		= 
SYMS		= 
LIBS		= KERNEL32.LIB GDI32.LIB USER32.LIB 

CFLAGS		=  -mn -C -WA -S -3 -a8 -c -gf 
LFLAGS		=  /CO /NOI /DE /NOPACKF /XN /NT /ENTRY:mainCRTStartup /BAS:4194304 /A:512
DEFINES		= -D_CONSOLE=1
!ELSE
OUTPUTDIR	= .
CREATEOUTPUTDIR	=
TARGETDIR	= .
CREATETARGETDIR	=

SYMROOT		= 
SYMS		= 
LIBS		= KERNEL32.LIB GDI32.LIB USER32.LIB 

CFLAGS		=  -mn -o+time -WA -3 -a8 -c 
LFLAGS		=  /NOI /DE /E /PACKF /XN /NT /ENTRY:mainCRTStartup /BAS:4194304 /A:512
DEFINES		= -D_CONSOLE=1
!ENDIF

HFLAGS		= $(CFLAGS) 
MFLAGS		= MASTERPROJ=$(PROJ) 
LIBFLAGS	=  /C 
RESFLAGS	=  -32 
DEBUGGERFLAGS	=  
AFLAGS		= $(CFLAGS) 
HELPFLAGS	= 

MODEL		= N

PAR		= PROJS BATS OBJS

RCDEFINES	= 

INCLUDES	= 

INCLUDEDOBJS	= 

OBJS		= compiler_tests.OBJ weak_attribute.OBJ bad_alloc.OBJ  \
		basic_string_defined.OBJ bool_keyeord.OBJ bool_keyword.OBJ broken_using.OBJ  \
		builtin_constructor_bug.OBJ check_for_wchar_t.OBJ check_for_yvals.OBJ const_member_constructor_bug.OBJ  \
		default_non_type_params.OBJ default_template_params.OBJ default_type_params.OBJ exception_header.OBJ  \
		exception_spec_works.OBJ exceptions_support.OBJ explicit_func_template_args.OBJ explicit_keyword.OBJ  \
		for_loop_inline_problems.OBJ friend_templates.OBJ func_tmpl_partial_order.OBJ inherited_template_typedefs_broken.OBJ  \
		inherited_typedefs_visible_from_outside.OBJ long_double_type.OBJ long_long_type.OBJ lrand48.OBJ  \
		member_template_classes.OBJ member_template_keyword.OBJ member_template_method.OBJ method_specialization.OBJ  \
		mutable_keyword.OBJ namespace.OBJ native_stdexcept.OBJ new_iostreams.OBJ  \
		new_style_casts.OBJ new_style_headers.OBJ new_style_new.OBJ non_template_param_baseclass_matching.OBJ  \
		non_type_param_bug.OBJ partial_class_spec_explicit_constructors1.OBJ partial_specialization.OBJ partial_template_func_ordering.OBJ  \
		patrial_class_spec_explicit_constructors.OBJ patrial_class_specialization.OBJ private_type_static_members_init.OBJ ptr_to_member_param_bug.OBJ  \
		qualified_friend_templates.OBJ return_after_throw.OBJ sizeof_int.OBJ static_array_member_size_bug.OBJ  \
		static_data_member_const_init_bug.OBJ static_data_member_template.OBJ stl_compat.OBJ template_param_baseclass_matching.OBJ  \
		trivial_constructor_bug.OBJ trivial_constructor_bug1.OBJ type_traits_automatic_specialization.OBJ typename_keyword.OBJ  \
		wchat_t_type.OBJ arrow_operator_instantiated.OBJ 

RCFILES		= 

RESFILES	= 

HELPFILES	= 

BATS		= 

.SUFFIXES: .C .CP .CPP .CXX .CC .H .HPP .HXX .COM .EXE .DLL .LIB .RTF .DLG .ASM .RES .RC .OBJ 

.C.OBJ:
	$(CC) $(CFLAGS) $(DEFINES) $(INCLUDES) -o$*.obj $*.c

.CPP.OBJ:
	$(CC) $(CFLAGS) $(DEFINES) $(INCLUDES) -o$*.obj $*.cpp

.CXX.OBJ:
	$(CC) $(CFLAGS) $(DEFINES) $(INCLUDES) -o$*.obj $*.cxx

.CC.OBJ:
	$(CC) $(CFLAGS) $(DEFINES) $(INCLUDES) -o$*.obj $*.cc

.CP.OBJ:
	$(CC) $(CFLAGS) $(DEFINES) $(INCLUDES) -o$*.obj $*.cp

.H.SYM:
	$(CC) $(HFLAGS) $(DEFINES) $(INCLUDES) -HF -o$(*B).sym $*.h

.HPP.SYM:
	$(CC) $(HFLAGS) $(DEFINES) $(INCLUDES) -HF -o$(*B).sym $*.hpp

.HXX.SYM:
	$(CC) $(HFLAGS) $(DEFINES) $(INCLUDES) -HF -o$(*B).sym $*.hxx

.C.EXP:
	$(CPP) $(CFLAGS) $(DEFINES) $(INCLUDES)   $*.c   -o$*.lst

.CPP.EXP:
	$(CPP) $(CFLAGS) $(DEFINES) $(INCLUDES) $*.cpp -o$*.lst

.CXX.EXP:
	$(CPP) $(CFLAGS) $(DEFINES) $(INCLUDES) $*.cxx -o$*.lst

.CP.EXP:
	$(CPP) $(CFLAGS) $(DEFINES) $(INCLUDES)  $*.cp  -o$*.lst

.CC.EXP:
	$(CPP) $(CFLAGS) $(DEFINES) $(INCLUDES)  $*.cc  -o$*.lst

.ASM.EXP:
	$(CPP) $(CFLAGS) $(DEFINES) $(INCLUDES) $*.asm -o$*.lst

.OBJ.COD:
	$(DISASM) $*.OBJ -c

!IF $(DEBUG)
.OBJ.EXE:
		$(LNK) $(LFLAGS) @<<$(PROJ).LNK
compiler_tests.OBJ+
weak_attribute.OBJ+
bad_alloc.OBJ+
basic_string_defined.OBJ+
bool_keyeord.OBJ+
bool_keyword.OBJ+
broken_using.OBJ+
builtin_constructor_bug.OBJ+
check_for_wchar_t.OBJ+
check_for_yvals.OBJ+
const_member_constructor_bug.OBJ+
default_non_type_params.OBJ+
default_template_params.OBJ+
default_type_params.OBJ+
exception_header.OBJ+
exception_spec_works.OBJ+
exceptions_support.OBJ+
explicit_func_template_args.OBJ+
explicit_keyword.OBJ+
for_loop_inline_problems.OBJ+
friend_templates.OBJ+
func_tmpl_partial_order.OBJ+
inherited_template_typedefs_broken.OBJ+
inherited_typedefs_visible_from_outside.OBJ+
long_double_type.OBJ+
long_long_type.OBJ+
lrand48.OBJ+
member_template_classes.OBJ+
member_template_keyword.OBJ+
member_template_method.OBJ+
method_specialization.OBJ+
mutable_keyword.OBJ+
namespace.OBJ+
native_stdexcept.OBJ+
new_iostreams.OBJ+
new_style_casts.OBJ+
new_style_headers.OBJ+
new_style_new.OBJ+
non_template_param_baseclass_matching.OBJ+
non_type_param_bug.OBJ+
partial_class_spec_explicit_constructors1.OBJ+
partial_specialization.OBJ+
partial_template_func_ordering.OBJ+
patrial_class_spec_explicit_constructors.OBJ+
patrial_class_specialization.OBJ+
private_type_static_members_init.OBJ+
ptr_to_member_param_bug.OBJ+
qualified_friend_templates.OBJ+
return_after_throw.OBJ+
sizeof_int.OBJ+
static_array_member_size_bug.OBJ+
static_data_member_const_init_bug.OBJ+
static_data_member_template.OBJ+
stl_compat.OBJ+
template_param_baseclass_matching.OBJ+
trivial_constructor_bug.OBJ+
trivial_constructor_bug1.OBJ+
type_traits_automatic_specialization.OBJ+
typename_keyword.OBJ+
wchat_t_type.OBJ+
arrow_operator_instantiated.OBJ
$$SCW$$.EXE
NUL
KERNEL32.LIB GDI32.LIB USER32.LIB 
compiler_tests.DEF;
<<
!ELSE
.OBJ.EXE:
		$(LNK) $(LFLAGS) @$(PROJ).LNK<<
compiler_tests.OBJ+
weak_attribute.OBJ+
bad_alloc.OBJ+
basic_string_defined.OBJ+
bool_keyeord.OBJ+
bool_keyword.OBJ+
broken_using.OBJ+
builtin_constructor_bug.OBJ+
check_for_wchar_t.OBJ+
check_for_yvals.OBJ+
const_member_constructor_bug.OBJ+
default_non_type_params.OBJ+
default_template_params.OBJ+
default_type_params.OBJ+
exception_header.OBJ+
exception_spec_works.OBJ+
exceptions_support.OBJ+
explicit_func_template_args.OBJ+
explicit_keyword.OBJ+
for_loop_inline_problems.OBJ+
friend_templates.OBJ+
func_tmpl_partial_order.OBJ+
inherited_template_typedefs_broken.OBJ+
inherited_typedefs_visible_from_outside.OBJ+
long_double_type.OBJ+
long_long_type.OBJ+
lrand48.OBJ+
member_template_classes.OBJ+
member_template_keyword.OBJ+
member_template_method.OBJ+
method_specialization.OBJ+
mutable_keyword.OBJ+
namespace.OBJ+
native_stdexcept.OBJ+
new_iostreams.OBJ+
new_style_casts.OBJ+
new_style_headers.OBJ+
new_style_new.OBJ+
non_template_param_baseclass_matching.OBJ+
non_type_param_bug.OBJ+
partial_class_spec_explicit_constructors1.OBJ+
partial_specialization.OBJ+
partial_template_func_ordering.OBJ+
patrial_class_spec_explicit_constructors.OBJ+
patrial_class_specialization.OBJ+
private_type_static_members_init.OBJ+
ptr_to_member_param_bug.OBJ+
qualified_friend_templates.OBJ+
return_after_throw.OBJ+
sizeof_int.OBJ+
static_array_member_size_bug.OBJ+
static_data_member_const_init_bug.OBJ+
static_data_member_template.OBJ+
stl_compat.OBJ+
template_param_baseclass_matching.OBJ+
trivial_constructor_bug.OBJ+
trivial_constructor_bug1.OBJ+
type_traits_automatic_specialization.OBJ+
typename_keyword.OBJ+
wchat_t_type.OBJ+
arrow_operator_instantiated.OBJ
$$SCW$$.EXE
NUL
KERNEL32.LIB GDI32.LIB USER32.LIB 
compiler_tests.DEF;
<<
!ENDIF

.RTF.HLP:
	$(HC) $(HELPFLAGS) $*.HPJ

.ASM.OBJ:
	$(ASM) $(AFLAGS) $(DEFINES) $(INCLUDES) -o$*.obj $*.asm

.RC.RES: 
	$(RC) $(RCDEFINES) $(RESFLAGS) $(INCLUDES) $*.rc -o$*.res

.DLG.RES:
	echo ^#include "windows.h" >$$$*.rc
	echo ^IF EXIST "$*.h" >>$$$*.rc
	echo ^#include "$*.h" >>$$$*.rc
	echo ^#include "$*.dlg" >>$$$*.rc
	$(RC) $(RCDEFINES) $(RESFLAGS) $(INCLUDES) $$$*.rc
	-del $*.res
	-ren $$$*.res $*.res



all:	noteout createdir $(PRECOMPILE) $(SYMS) $(OBJS) $(INCLUDEDOBJS) $(POSTCOMPILE) $(TARGETDIR)\$(PROJ).$(PROJTYPE) $(POSTLINK) _done


all2:	createdir $(PRECOMPILE) $(SYMS) $(OBJS) $(INCLUDEDOBJS) $(POSTCOMPILE) $(TARGETDIR)\$(PROJ).$(PROJTYPE) $(POSTLINK) _done

noteout:
	REM Output to $(OUTPUTDIR)

createdir:
	$(CREATEOUTPUTDIR)
	$(CREATETARGETDIR)
	
$(TARGETDIR)\$(PROJ).$(PROJTYPE): $(OBJS) $(INCLUDEDOBJS) $(RCFILES) $(RESFILES) $(HELPFILES) $(DEFFILE)
			-del $(TARGETDIR)\$(PROJ).$(PROJTYPE)
!IF $(DEBUG)
		$(LNK) $(LFLAGS) @<<$(PROJ).LNK
compiler_tests.OBJ+
weak_attribute.OBJ+
bad_alloc.OBJ+
basic_string_defined.OBJ+
bool_keyeord.OBJ+
bool_keyword.OBJ+
broken_using.OBJ+
builtin_constructor_bug.OBJ+
check_for_wchar_t.OBJ+
check_for_yvals.OBJ+
const_member_constructor_bug.OBJ+
default_non_type_params.OBJ+
default_template_params.OBJ+
default_type_params.OBJ+
exception_header.OBJ+
exception_spec_works.OBJ+
exceptions_support.OBJ+
explicit_func_template_args.OBJ+
explicit_keyword.OBJ+
for_loop_inline_problems.OBJ+
friend_templates.OBJ+
func_tmpl_partial_order.OBJ+
inherited_template_typedefs_broken.OBJ+
inherited_typedefs_visible_from_outside.OBJ+
long_double_type.OBJ+
long_long_type.OBJ+
lrand48.OBJ+
member_template_classes.OBJ+
member_template_keyword.OBJ+
member_template_method.OBJ+
method_specialization.OBJ+
mutable_keyword.OBJ+
namespace.OBJ+
native_stdexcept.OBJ+
new_iostreams.OBJ+
new_style_casts.OBJ+
new_style_headers.OBJ+
new_style_new.OBJ+
non_template_param_baseclass_matching.OBJ+
non_type_param_bug.OBJ+
partial_class_spec_explicit_constructors1.OBJ+
partial_specialization.OBJ+
partial_template_func_ordering.OBJ+
patrial_class_spec_explicit_constructors.OBJ+
patrial_class_specialization.OBJ+
private_type_static_members_init.OBJ+
ptr_to_member_param_bug.OBJ+
qualified_friend_templates.OBJ+
return_after_throw.OBJ+
sizeof_int.OBJ+
static_array_member_size_bug.OBJ+
static_data_member_const_init_bug.OBJ+
static_data_member_template.OBJ+
stl_compat.OBJ+
template_param_baseclass_matching.OBJ+
trivial_constructor_bug.OBJ+
trivial_constructor_bug1.OBJ+
type_traits_automatic_specialization.OBJ+
typename_keyword.OBJ+
wchat_t_type.OBJ+
arrow_operator_instantiated.OBJ
$$SCW$$.EXE
NUL
KERNEL32.LIB GDI32.LIB USER32.LIB 
compiler_tests.DEF;
<<
!ELSE
		$(LNK) $(LFLAGS) @<<$(PROJ).LNK
compiler_tests.OBJ+
weak_attribute.OBJ+
bad_alloc.OBJ+
basic_string_defined.OBJ+
bool_keyeord.OBJ+
bool_keyword.OBJ+
broken_using.OBJ+
builtin_constructor_bug.OBJ+
check_for_wchar_t.OBJ+
check_for_yvals.OBJ+
const_member_constructor_bug.OBJ+
default_non_type_params.OBJ+
default_template_params.OBJ+
default_type_params.OBJ+
exception_header.OBJ+
exception_spec_works.OBJ+
exceptions_support.OBJ+
explicit_func_template_args.OBJ+
explicit_keyword.OBJ+
for_loop_inline_problems.OBJ+
friend_templates.OBJ+
func_tmpl_partial_order.OBJ+
inherited_template_typedefs_broken.OBJ+
inherited_typedefs_visible_from_outside.OBJ+
long_double_type.OBJ+
long_long_type.OBJ+
lrand48.OBJ+
member_template_classes.OBJ+
member_template_keyword.OBJ+
member_template_method.OBJ+
method_specialization.OBJ+
mutable_keyword.OBJ+
namespace.OBJ+
native_stdexcept.OBJ+
new_iostreams.OBJ+
new_style_casts.OBJ+
new_style_headers.OBJ+
new_style_new.OBJ+
non_template_param_baseclass_matching.OBJ+
non_type_param_bug.OBJ+
partial_class_spec_explicit_constructors1.OBJ+
partial_specialization.OBJ+
partial_template_func_ordering.OBJ+
patrial_class_spec_explicit_constructors.OBJ+
patrial_class_specialization.OBJ+
private_type_static_members_init.OBJ+
ptr_to_member_param_bug.OBJ+
qualified_friend_templates.OBJ+
return_after_throw.OBJ+
sizeof_int.OBJ+
static_array_member_size_bug.OBJ+
static_data_member_const_init_bug.OBJ+
static_data_member_template.OBJ+
stl_compat.OBJ+
template_param_baseclass_matching.OBJ+
trivial_constructor_bug.OBJ+
trivial_constructor_bug1.OBJ+
type_traits_automatic_specialization.OBJ+
typename_keyword.OBJ+
wchat_t_type.OBJ+
arrow_operator_instantiated.OBJ
$$SCW$$.EXE
NUL
KERNEL32.LIB GDI32.LIB USER32.LIB 
compiler_tests.DEF;
<<
!ENDIF

			-ren $(TARGETDIR)\$$SCW$$.$(PROJTYPE) $(PROJ).$(PROJTYPE)
			-echo $(TARGETDIR)\$(PROJ).$(PROJTYPE) built

_done:
		REM  Project is up to date

buildall:	clean	all


clean:
		-del $(TARGETDIR)\$$SCW$$.$(PROJTYPE)
		-del $(PROJ).CLE
		-del $(OUTPUTDIR)\SCPH.SYM
		-del compiler_tests.dpd
		-del $(OBJS)

cleanres:

res:		cleanres $(RCFILES) all


link:
!IF $(DEBUG)
		$(LNK) $(LFLAGS) @<<$(PROJ).LNK
compiler_tests.OBJ+
weak_attribute.OBJ+
bad_alloc.OBJ+
basic_string_defined.OBJ+
bool_keyeord.OBJ+
bool_keyword.OBJ+
broken_using.OBJ+
builtin_constructor_bug.OBJ+
check_for_wchar_t.OBJ+
check_for_yvals.OBJ+
const_member_constructor_bug.OBJ+
default_non_type_params.OBJ+
default_template_params.OBJ+
default_type_params.OBJ+
exception_header.OBJ+
exception_spec_works.OBJ+
exceptions_support.OBJ+
explicit_func_template_args.OBJ+
explicit_keyword.OBJ+
for_loop_inline_problems.OBJ+
friend_templates.OBJ+
func_tmpl_partial_order.OBJ+
inherited_template_typedefs_broken.OBJ+
inherited_typedefs_visible_from_outside.OBJ+
long_double_type.OBJ+
long_long_type.OBJ+
lrand48.OBJ+
member_template_classes.OBJ+
member_template_keyword.OBJ+
member_template_method.OBJ+
method_specialization.OBJ+
mutable_keyword.OBJ+
namespace.OBJ+
native_stdexcept.OBJ+
new_iostreams.OBJ+
new_style_casts.OBJ+
new_style_headers.OBJ+
new_style_new.OBJ+
non_template_param_baseclass_matching.OBJ+
non_type_param_bug.OBJ+
partial_class_spec_explicit_constructors1.OBJ+
partial_specialization.OBJ+
partial_template_func_ordering.OBJ+
patrial_class_spec_explicit_constructors.OBJ+
patrial_class_specialization.OBJ+
private_type_static_members_init.OBJ+
ptr_to_member_param_bug.OBJ+
qualified_friend_templates.OBJ+
return_after_throw.OBJ+
sizeof_int.OBJ+
static_array_member_size_bug.OBJ+
static_data_member_const_init_bug.OBJ+
static_data_member_template.OBJ+
stl_compat.OBJ+
template_param_baseclass_matching.OBJ+
trivial_constructor_bug.OBJ+
trivial_constructor_bug1.OBJ+
type_traits_automatic_specialization.OBJ+
typename_keyword.OBJ+
wchat_t_type.OBJ+
arrow_operator_instantiated.OBJ
$$SCW$$.EXE
NUL
KERNEL32.LIB GDI32.LIB USER32.LIB 
compiler_tests.DEF;
<<
!ELSE
		$(LNK) $(LFLAGS) @<<$(PROJ).LNK
compiler_tests.OBJ+
weak_attribute.OBJ+
bad_alloc.OBJ+
basic_string_defined.OBJ+
bool_keyeord.OBJ+
bool_keyword.OBJ+
broken_using.OBJ+
builtin_constructor_bug.OBJ+
check_for_wchar_t.OBJ+
check_for_yvals.OBJ+
const_member_constructor_bug.OBJ+
default_non_type_params.OBJ+
default_template_params.OBJ+
default_type_params.OBJ+
exception_header.OBJ+
exception_spec_works.OBJ+
exceptions_support.OBJ+
explicit_func_template_args.OBJ+
explicit_keyword.OBJ+
for_loop_inline_problems.OBJ+
friend_templates.OBJ+
func_tmpl_partial_order.OBJ+
inherited_template_typedefs_broken.OBJ+
inherited_typedefs_visible_from_outside.OBJ+
long_double_type.OBJ+
long_long_type.OBJ+
lrand48.OBJ+
member_template_classes.OBJ+
member_template_keyword.OBJ+
member_template_method.OBJ+
method_specialization.OBJ+
mutable_keyword.OBJ+
namespace.OBJ+
native_stdexcept.OBJ+
new_iostreams.OBJ+
new_style_casts.OBJ+
new_style_headers.OBJ+
new_style_new.OBJ+
non_template_param_baseclass_matching.OBJ+
non_type_param_bug.OBJ+
partial_class_spec_explicit_constructors1.OBJ+
partial_specialization.OBJ+
partial_template_func_ordering.OBJ+
patrial_class_spec_explicit_constructors.OBJ+
patrial_class_specialization.OBJ+
private_type_static_members_init.OBJ+
ptr_to_member_param_bug.OBJ+
qualified_friend_templates.OBJ+
return_after_throw.OBJ+
sizeof_int.OBJ+
static_array_member_size_bug.OBJ+
static_data_member_const_init_bug.OBJ+
static_data_member_template.OBJ+
stl_compat.OBJ+
template_param_baseclass_matching.OBJ+
trivial_constructor_bug.OBJ+
trivial_constructor_bug1.OBJ+
type_traits_automatic_specialization.OBJ+
typename_keyword.OBJ+
wchat_t_type.OBJ+
arrow_operator_instantiated.OBJ
$$SCW$$.EXE
NUL
KERNEL32.LIB GDI32.LIB USER32.LIB 
compiler_tests.DEF;
<<
!ENDIF

		-del $(TARGETDIR)\$(PROJ).$(PROJTYPE)
		-ren $(TARGETDIR)\$$SCW$$.$(PROJTYPE) $(PROJ).$(PROJTYPE)




!IF EXIST (compiler_tests.dpd)
!INCLUDE compiler_tests.dpd
!ENDIF


