// compiler_tests.cpp : main implementation file
//
// Copyright (c) XYZ Corporation, 2000. All Rights Reserved.
//
//


#include	<stdio.h>
#ifndef _CONSOLE
#include <winio.h>
#endif
#ifdef  _WINIO
#include 	<string.h> // For strcpy
#endif

#include "test_config.h"


void main(int argc, char *argv[])
{
    /* for Win16 Console Applications, _WINIO is defined */
#ifdef _WINIO
    /* By default, Winio sets the title bar to the exe name, use winio_settitle to change it */
    winio_settitle(__hMainWnd,"compiler_tests");
    /* Your about box by default shows the exe name, you can change it by resetting __szModule
       and passing the reset value to winio_about */
    strcpy (__szModule,"compiler_tests");
    winio_about(__szModule);
#endif

    test_weak_attribute();
    test_bad_alloc();
    test_for_string_header();
    test_for_bool();
    test_for_bool_keyword();
    test_for_broken_using_directive();
    test_for_default_constructor_bug(0, NULL);
    check_for_yvals_h();
    const_member_constructor_bug();
    test_limited_default_templates();
    test_default_type_param();
    test_for_exception_h();
    test_exception_support();
    test_explicit_func_tmpl_args();
    test_for_explicit();
    test_for_loop_inline_problems();
    test_for_friend_templates();
    test_function_tmpl_partial_order();
    test_base_typedef_bug();
    test_for_lrand48();
    test_member_template_classes();
    test_member_template_keyword();
    test_member_templates();
    test_for_mutable();
    test_for_stdexcept_header();
    test_for_new_iostreams();
    test_new_style_casts();
    test_new_style_headers();
    test_new_style_new();
    test_for_nontempl_base_match_bug();
    test_for_non_type_tmpl_param_bug();
    test_partial_spec_needs_template_args();
    test_partial_spec_needs_template_args1();
    test_partial_specialization_syntax();
    test_no_func_tmpl_partial_order();
    test_partial_specialization();
    test_member_ptr_param_bug();
    test_qualified_friends();
    test_throw_return_bug();
    test_for_automatic_type_traits();
    test_wchart_is_ushort();
    test_no_arrow_operator();
    check_for_wchar_t();
    test_default_non_type_param();
    test_exception_spec_works();
    test_base_typedef_outside_bug();
    test_long_double_type();
    test_long_long_type();
    test_method_specialization();
    test_namespace();
    test_private_unint();
    check_sizeof_int();
    test_static_array_bug();
    test_static_const_init_bug();
    test_static_template_data();
    check_basic_stl_compatability();
    test_base_match_bug();
    test_trivial_constructor_bug();
    test_trivial_constructor_bug1();


	/* for Win32 Console Applications, _CONSOLE is defined */
#ifdef _CONSOLE
   {
    /* Print a prompt prior to exiting so that you can view output */
    int c;
    printf ("Press Return To Exit: ");
    c = getc(stdin);
   }
#endif
}
