/*
 * __STL_NO_EXPLICIT_FUNCTION_TMPL_ARGS
 */
#include <stdio.h>
#include "test_config.h"

#ifdef TEST_EXPLICIT_FUNCTION_TMPL_ARGS

template <class T> class foo;
template<class T> bool operator==(const foo<T>& lhs,const foo<T>& rhs);
template <class T> class foo {
private:
T bar;
friend bool operator== <> (const foo<T>&,const foo<T>&);
};


template<class T> bool operator==(const foo<T>& lhs,const foo<T>& rhs) {
return  lhs.bar==rhs.bar;
}

int test_explicit_func_tmpl_args()
{
  foo<int> f1, f2;
  int ret= (f1==f2)
  printf("#undef __STL_NO_EXPLICIT_FUNCTION_TMPL_ARGS\n");
  return 1;
}

#else
int test_explicit_func_tmpl_args()
{
  printf("#define __STL_NO_EXPLICIT_FUNCTION_TMPL_ARGS\n");
  return 1;
}


#endif