/*
 * __STL_NO_FUNCTION_TMPL_PARTIAL_ORDER
 */
#include <stdio.h>
#include "test_config.h"

#ifdef TEST_FUNCTION_TMPL_PARTIAL_ORDER

template <class Arg,class Result>
Result po_foo (const Arg& a,const Result&)
  { return (Result)a.nothing; }

template <class T>
struct A {
	T a;
	A(int _a) : a(_a) {}
};

template<class T>
T po_foo (const A<T>& a, const A<T>& b)    // should resolve to this
{ return a.a; }

int test_function_tmpl_partial_order()
{
  A<int> po_a(0);
  A<int> po_b(1);
  (void)po_foo(po_b, po_a);

  printf("#undef __STL_NO_FUNCTION_TMPL_PARTIAL_ORDER\n");
  return 1;
}

#else

int test_function_tmpl_partial_order()
{
  printf("#define __STL_NO_FUNCTION_TMPL_PARTIAL_ORDER\n");
  return 1;
}

#endif
