/*
 * __STL_BASE_TYPEDEF_BUG
 * __STL_BASE_TYPEDEF_OUTSIDE_BUG
 */
#include <stdio.h>
#include "test_config.h"

#ifdef TEST_BASE_TYPEDEF_BUG
template <class Arg1, class Arg2, class Result>
struct binary_function {
    typedef Arg1 first_argument_type;
    typedef Arg2 second_argument_type;
    typedef Result result_type;
};

template <class T>
struct equal_to : public binary_function<T, T, int> {
    int operator()(const T& x, const T& y) const { return x == y; }
};

template <class Predicate>
class binary_negate
    : public binary_function<__TYPENAME Predicate::first_argument_type,
			     __TYPENAME Predicate::second_argument_type,
                             int> {
protected:
    Predicate pred;
public:
    binary_negate(const Predicate& x = Predicate()) : pred(x) {}
    int operator() (const __TYPENAME Predicate::first_argument_type& x,
		    const __TYPENAME Predicate::second_argument_type& y) const {
	return !pred(x, y);
    }
};
      typedef equal_to<int> eq_int;
      typedef binary_negate<equal_to<int> > int_negate;
      int_negate n;

int test_base_typedef_bug()
{
  (void)n(1,2);

  printf("#undef __STL_BASE_TYPEDEF_BUG\n");
  printf("#undef __STL_BASE_TYPEDEF_OUTSIDE_BUG // also check for a define\n");
  return 1;
}

#else
int test_base_typedef_bug()
{
  printf("#define __STL_BASE_TYPEDEF_BUG\n");
  printf("#define __STL_BASE_TYPEDEF_OUTSIDE_BUG\n");
  return 1;
}

#endif