/*
 * __STL_NO_MEMBER_TEMPLATE_CLASSES
 */
#include <stdio.h>
#include "test_config.h"

#ifdef TEST_FOR_MEMBER_TEMPLATE_CLASSES
template <class Result>
struct nt_foo {
    typedef Result result_type;
    template <class Arg> 
    struct rebind
    {  typedef nt_foo<Arg> other; };
};

template <class _Tp, class _Allocator>
struct _Traits
{
  typedef typename _Allocator::rebind<_Tp> my_rebind;
  typedef typename my_rebind::other allocator_type;
};

nt_foo<char> p;
_Traits< int, nt_foo<short> > pp;

int test_member_template_classes()
{
  printf("#undef __STL_NO_MEMBER_TEMPLATE_CLASSES\n");
  return 1;
}

#else
int test_member_template_classes()
{
  printf("#define __STL_NO_MEMBER_TEMPLATE_CLASSES\n");
  return 1;
}


#endif
