/*
 * __STL_NO_MEMBER_TEMPLATE_KEYWORD
 */
#include <stdio.h>
#include "test_config.h"

#ifdef TEST_MEMBER_TEMPLATE_KEYWORD

// typename is required for this test

#define TYPENAME_KEYWORD typename

template <class Result>
struct nt_foo {
    typedef Result result_type;
    template <class Arg> struct rebind {  typedef nt_foo<Arg> other; };
};

template <class _Tp, class _Allocator>
struct _Traits
{
  typedef TYPENAME_KEYWORD _Allocator:: template rebind<_Tp> my_rebind;
  typedef TYPENAME_KEYWORD my_rebind::other allocator_type;
};

nt_foo<char> p;
_Traits< int, nt_foo<short> > pp;

int test_member_template_keyword()
{
  printf("#undef __STL_NO_MEMBER_TEMPLATE_KEYWORD\n");
  return 1;
}

#else

int test_member_template_keyword()
{
  printf("#define __STL_NO_MEMBER_TEMPLATE_KEYWORD\n");
  return 1;
}

#endif