/*
 * for basic STL compatibility
 */
#include <stdio.h>

template <class Arg1, class Arg2, class Result>
struct binary_function {
    typedef Arg1 first_argument_type;
    typedef Arg2 second_argument_type;
    typedef Result result_type;
};
template <class T>
struct plus : public binary_function<T, T, T> {
    T operator()(const T& x, const T& y) const;
};

template <class T>
T plus<T>::operator()(const T& x, const T& y) const { return x + y; }
plus<int> p;

int check_basic_stl_compatability()
{
  printf("//PASS: basic STL compatability\n");
  return 1;
}
