/*
 * __STL_NEED_TYPENAME
 */
#include <stdio.h>
#include "test_config.h"

#ifdef TEST_FOR_TYPENAME
template <class T1, class T2>
struct pair {
    typedef T1 first_type;
    typedef T2 second_type;
};

template <class Arg, class Result>
struct unary_function {
    typedef Arg argument_type;
    typedef Result result_type;
};

template <class Pair>
struct select2nd : public unary_function<Pair, typename Pair::second_type> {
  typedef typename Pair::first_type ignored_type;
  const typename Pair::second_type& operator()(const typename Pair::second_type& x,
						const ignored_type& ) const
  {
    return x;
  }

};

int test_for_typename()
{
	typedef pair<int,int> tn_p;
	select2nd< tn_p > tn_s;
	(void)tn_s(1,5);

  printf("#define __STL_NEED_TYPENAME 1\n");
  return 1;
}

#else
int test_for_typename()
{
  printf("#undef __STL_NEED_TYPENAME\n");
  return 1;
}

#endif
